#include "probe.h"

char *vargv[3] = {"probe","-xrm","*workspaceList: One Two"};

int vargc = 3;
int main(int argc, char *argv[]) {
  Widget toplevel;
  XtAppContext appContext;
  char *tmp;

  static String fallbackResources[] = {
    "Probe*background: #b0c3ca",
    "Probe*foreground: black",
    NULL,
  };

  toplevel = XtVaAppInitialize(&appContext, "Probe", NULL, 0,
    &argc, argv, fallbackResources,
    XtVaTypedArg,"workspaceList",XmRString,"One Two",strlen("Two")+1,
    NULL);

  if (argc > 2) {
    cerr << "usage: caget <variable>" << endl;
    return 0;
  }

  xCA CA(appContext);          // initialize the Channel AccessA
  vCh RvCh("RvCh.RTYP");
  CA.add(RvCh);
  
  myCh ch(toplevel,"", &RvCh);  // create a channel
  CA.add(ch);                  // add the channel

  if (argc == 2) {
    ch.name(argv[1]);
  }

  SEVCHK(CA.status(),"CA.buildAndConnect failed");
  XtRealizeWidget(toplevel);
  ch.helpCb(toplevel,&ch,NULL);
  // fix the size of the toplevel widget
  Dimension w, h;
  XtVaGetValues(toplevel,
    XmNwidth, &w,
    XmNheight, &h,
    NULL);
  XtVaSetValues(toplevel,
    XmNminWidth, w,
    XmNmaxWidth, w,
    XmNminHeight, h,
    XmNmaxHeight, h,
    NULL);
  XtAppMainLoop(appContext);
  return 0;
}






