#include "vObject.h"

Widget topShell(Widget widget) {
  while (widget && !XtIsWMShell(widget))
    widget = XtParent(widget);
  return widget;
}

vDialog::vDialog(Widget parent, char *name) {

  // create a dialog shell
  _dialog = XtVaCreatePopupShell(name,
	    xmDialogShellWidgetClass, topShell(parent),
	    XmNdeleteResponse, XmDO_NOTHING,
	    NULL);

  // create a panedWindow widget to hold everything
  _panel = XtVaCreateWidget("panel",
	   xmPanedWindowWidgetClass, _dialog,
           XmNsashWidth, 1,
           XmNsashHeight, 1,
	   NULL);
  return;
}

vDialog::~vDialog() {
  // destroy Dialog
  XtDestroyWidget(_dialog);
}

void vDialog::manage() {
  Dimension w, h;
  XtManageChild(_panel);
  XtManageChild(_dialog);
  XtVaGetValues(_dialog,
    XmNwidth, &w,
    XmNheight, &h,
    NULL);
  XtVaSetValues(_dialog,
    XmNminWidth, w,
    XmNmaxWidth, w,
    XmNminHeight, h,
    XmNmaxHeight, h,
    NULL);
}

void vDialog::unmanage() {
  XtUnmanageChild(_dialog);
  XtUnmanageChild(_panel);
  return;
}

void vDialog::moveTo(int x, int y) {
  XtVaSetValues(_dialog,
    XmNx, x,
    XmNy, y,
    NULL);
  return;
}

vFrame::vFrame(Widget parent, char *name) {
  // create a frame widget
  _frame = XtVaCreateWidget("frame",
	   xmFrameWidgetClass, parent,
	   XmNshadowType, XmSHADOW_ETCHED_IN,
	   NULL);

  // create a label widget
  _label = XtVaCreateWidget(name,
	   xmLabelWidgetClass, _frame,
	   XmNchildType, XmFRAME_TITLE_CHILD,
	   NULL);
  return;
}

vFrame::~vFrame() {
  // destroy Frame
  XtDestroyWidget(_frame);
}

void vFrame::manage() {
  XtManageChild(_label);
  XtManageChild(_frame);
  return;
}

void vFrame::unmanage() {
  XtUnmanageChild(_frame);
  XtUnmanageChild(_label);
  return;
}
